﻿using System;
using System.IO;
using System.Reflection;
using System.Threading.Tasks;

using Windows.Storage;

namespace TestProject
{
    /// <summary>
    /// 파일 헬퍼
    /// </summary>
    public static class FileHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 텍스트 파일 로드하기 (비동기) - LoadTextFileAsync(relativeFilePath)

        /// <summary>
        /// 텍스트 파일 로드하기 (비동기)
        /// </summary>
        /// <param name="relativeFilePath">상대적인 파일 경로</param>
        /// <returns>텍스트</returns>
        public static async Task<string> LoadTextFileAsync(string relativeFilePath)
        {
            StorageFile storageFile = null;

            if(!NativeHelper.IsAppPackaged)
            {
                string entryAssemblyFilePath     = Assembly.GetEntryAssembly().Location;
                string entryAssemblyDirectorPath = Path.GetDirectoryName(entryAssemblyFilePath);
                string filePath                  = Path.Combine(entryAssemblyDirectorPath, relativeFilePath);
                string finalFilePath             = Path.GetFullPath(filePath);

                storageFile = await StorageFile.GetFileFromPathAsync(finalFilePath);
            }
            else
            {
                Uri sourceURI = new Uri($"ms-appx:///{relativeFilePath}");

                storageFile = await StorageFile.GetFileFromApplicationUriAsync(sourceURI);
            }

            return await FileIO.ReadTextAsync(storageFile);
        }

        #endregion
    }
}