using System.Collections.Generic;
using System.Text.Json;

using Windows.ApplicationModel.DataTransfer;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            Loaded                          += Page_Loaded;
            this.itemsView.SelectionChanged += itemsView_SelectionChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ε óϱ - Page_Loaded(sender, e)

        /// <summary>
        ///  ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private async void Page_Loaded(object sender, RoutedEventArgs e)
        {
            string text = await FileHelper.LoadTextFileAsync("/DATA/IconsData.json");

            List<IconInfo> iconInfoList = JsonSerializer.Deserialize<List<IconInfo>>
            (
                text,
                new JsonSerializerOptions { PropertyNameCaseInsensitive = true }
            );

            this.itemsView.ItemsSource = iconInfoList;
        }

        #endregion
        #region     óϱ - itemsView_SelectionChanged(sender, e)

        /// <summary>
        ///     óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void itemsView_SelectionChanged(ItemsView sender, ItemsViewSelectionChangedEventArgs e)
        {
            if(sender.SelectedItem != null)
            {
                IconInfo iconInfo = sender.SelectedItem as IconInfo;

                DataPackage dataPackage = new DataPackage();

                dataPackage.SetText(iconInfo.Code);

                Clipboard.SetContent(dataPackage);
            }
        }

        #endregion
    }
}