﻿using System.Runtime.InteropServices;

namespace TestProject
{
    /// <summary>
    /// 네이티브 헬퍼
    /// </summary>
    public class NativeHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Import
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 현재 패키지 ID 구하기 - GetCurrentPackageId(bufferLength, buffer)

        /// <summary>
        /// 현재 패키지 ID 구하기
        /// </summary>
        /// <param name="bufferLength">버퍼 길이</param>
        /// <param name="buffer">버퍼</param>
        /// <returns>처리 결과</returns>
        [DllImport("api-ms-win-appmodel-runtime-l1-1-1", SetLastError = true)]
        [return : MarshalAs(UnmanagedType.U4)]
        private static extern uint GetCurrentPackageId(ref int bufferLength, out byte buffer);

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// ERROR_SUCCESS
        /// </summary>
        public const int ERROR_SUCCESS = 0;

        /// <summary>
        /// ERROR_INSUFFICIENT_BUFFER
        /// </summary>
        public const int ERROR_INSUFFICIENT_BUFFER = 122;

        /// <summary>
        /// APPMODEL_ERROR_NO_PACKAGE
        /// </summary>
        public const int APPMODEL_ERROR_NO_PACKAGE = 15700;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 애플리케이션 패키지 여부 - IsAppPackaged

        /// <summary>
        /// 애플리케이션 패키지 여부
        /// </summary>
        public static bool IsAppPackaged
        {
            get
            {
                int  bufferSize = 0;
                uint lastError  = GetCurrentPackageId(ref bufferSize, out _);
                bool isPackaged = true;

                if(lastError == APPMODEL_ERROR_NO_PACKAGE)
                {
                    isPackaged = false;
                }

                return isPackaged;
            }
        }

        #endregion
    }
}